/******************************************************************************
 * $Id$
 * 
 * Source File Name: cmaps.h
 * 
 *   	 Copyright (c) 1991-96 International Business Machines Corp.
 *                     11400 Burnet Rd. Austin, TX. 78758
 *  
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of International Business Machines Corp. may not be used in 
 * any advertising or publicity relating to the software without the specific, 
 * prior written permission of International Business Machines Corp.
 * 
 * The software is provided AS-IS and without WARRANTY of any kind,
 * express, implied or otherwise, including without limitation, any
 * warranty of merchantabilityl or fitness for a particular purpose.
 * 
 * In no event shall International Business Machines Corp. be liable for any 
 * special, incidental, indirect or consequential damages of any kind, or any 
 * damages whatsoever resulting from loss of use, data or profits, whether or 
 * not advised of the possibility of damage, and on any theory of liability, 
 * arising out of or in connection with the use or performance of this 
 * software. Contractor is International Business Machines Corp.
 * 
 * Language: C
 * 
 * Description: 
 * 
 * Revision History: 
 *  01/07/97  Ronald O. Edmark  Initial Coding.
 *     
 *****************************************************************************/
#ifndef CS_CMAPS_H
#define CS_CMAPS_H

#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <assert.h>
#include "sovLayerUtil.h"
#include "cmapscope_ui.h"

#define TABLESIZE 133
#define CELLW  25
#define CELLH  25
#define CELL   16
#define WIDTH  400
#define HEIGHT 400

/* The position of class names match #define in X.h */
#define EMPTY -1
#define FULL 0
#define NEW  1
#define OLD  2
#define NOTFOUND 2

static char* CSXVisualClassNames[] = 
{
  "StaticGray", 
  "GrayScale", 
  "StaticColor", 
  "PseudoColor", 
  "TrueColor", 
  "DirectColor"
};

static char* CSXVisualTypes[] = 
{ 
  /*  "Underlay", */
  "Normal",
  "Overlay",
  /*  "Popup" */
};

typedef struct
{
  Colormap      cmap_id;      /* COLORMAP or None */
  int           cmap_cells;  
  int           depth;        /* Number of bit per pixel */
  Bool          state;        /* ColormapInstalled, ColormapUninstalled */
  unsigned long ref_cnt;      /* Number of windows that reference it */
  int           visual_type;  /* Underlay, Normal, Overlay, Popup */
  int           visual_class; /* StaticColor, PseudoColor, ... */
  unsigned long install_req;  /* Number if install requests */
  Visual*       visual;
  int           window_class;
  GC            gc;
  Window        window;
  Bool          notify;
} CSCmapInfoRec, *CSCmapInfo;

static CSCmapInfoRec *cmaps_table[TABLESIZE];
static int cmaps_locations[TABLESIZE]; /* Order of cmap in cmaps_table */
static int total_cmaps, current_cmap;

#endif

