/******************************************************************************
 * $Id$
 * 
 * Source File Name: cmapscope_ui.c
 * 
 *   	 Copyright (c) 1991-96 International Business Machines Corp.
 *                     11400 Burnet Rd. Austin, TX. 78758
 *  
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of International Business Machines Corp. may not be used in 
 * any advertising or publicity relating to the software without the specific, 
 * prior written permission of International Business Machines Corp.
 * 
 * The software is provided AS-IS and without WARRANTY of any kind,
 * express, implied or otherwise, including without limitation, any
 * warranty of merchantabilityl or fitness for a particular purpose.
 * 
 * In no event shall International Business Machines Corp. be liable for any 
 * special, incidental, indirect or consequential damages of any kind, or any 
 * damages whatsoever resulting from loss of use, data or profits, whether or 
 * not advised of the possibility of damage, and on any theory of liability, 
 * arising out of or in connection with the use or performance of this 
 * software. Contractor is International Business Machines Corp.
 * 
 * Language: "C"
 * 
 * Description: 
 * 
 * Revision History: 
 *  01/07/97  Ronald O. Edmark  Initial Coding.
 *     
 *****************************************************************************/
#include <stdlib.h>
#include <string.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>
#include <Xm/MwmUtil.h>
#include <Xm/PanedW.h>
#include <Xm/MainW.h>
#include <Xm/Form.h>
#include <Xm/Frame.h>
#include <Xm/DrawingA.h>
#include <Xm/RowColumn.h>
#include <Xm/Separator.h>
#include <Xm/PushB.h>
#include <Xm/ScrollBar.h>
#include <Xm/Label.h>
#include <Xm/TextF.h>
#include <Xm/ToggleB.h>
#include <Xm/ScrolledW.h>
#include <Xm/List.h>
#include <Xm/Text.h>
#include "Cmapscope.h"
#include "cmapscope_ui.h"

void dtb_change_map(Widget, XtPointer, XtPointer);
void dtb_draw_expose(Widget, XtPointer, XtPointer);
void dtb_quit(Widget, XtPointer, XtPointer);

/* Interface routines and data for Cmapscope */
static Widget drawing;
Widget dtb_get_drawing_widget()
{
  return drawing;
}

void dtb_update_dialog(char fields[][24])
{
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield,
                      fields[0]);
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield2,
                      fields[1]);
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield3,
                      fields[2]);
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield4,
                      fields[3]);
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield5,
                      fields[4]);
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield6,
                      fields[5]);
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield7,
                      fields[6]);
   XmTextFieldSetString(dtb_cmapscopeui_cmapscopewindow.textfield8,
                      fields[7]);
}

void dtb_create_list(char cmap_id[][16], int total_cmaps)
{
  int i;
  XmString motif_string;

  for (i = 0; i < total_cmaps; i++) {
    motif_string = XmStringCreateLocalized(cmap_id[i]);
    XmListAddItem(dtb_cmapscopeui_cmapscopewindow.list2, motif_string, 0);
    XmStringFree(motif_string);
  }
}

DtbCmapscopeuiCmapscopewindowInfoRec	dtb_cmapscopeui_cmapscopewindow = 
{
    False	 /* initialized */
};

/*
 * Widget create procedure decls
 */
static int dtb_cmapscopeui_cmapscopewindow_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_controlpane_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_drawpane_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield2_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield3_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield4_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield5_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield6_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield7_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield8_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_separator_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_radiobox_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield9_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_textfield10_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_list2_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);
static int dtb_cmapscopeui_button2_create(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);

int 
dtbCmapscopeuiCmapscopewindowInfo_clear(DtbCmapscopeuiCmapscopewindowInfo instance)
{
    memset((void *)(instance), (int)0, (size_t)sizeof(*instance));
    return 0;
}

int 
dtb_cmapscopeui_cmapscopewindow_initialize(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
  char buff[12];

    if (instance->initialized)
    {
        return 0;
    }
    instance->initialized = True;

    dtb_cmapscopeui_cmapscopewindow_create(instance,
        parent);
    dtb_cmapscopeui_controlpane_create(instance,
        instance->cmapscopewindow_form);
    dtb_cmapscopeui_drawpane_create(instance,
        instance->cmapscopewindow_form);
    dtb_cmapscopeui_textfield_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield2_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield3_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield4_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield5_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield6_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield7_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield8_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_separator_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_radiobox_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield9_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_textfield10_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_list2_create(instance,
        instance->controlpane);
    dtb_cmapscopeui_button2_create(instance,
        instance->controlpane);
    
    /*
     * Add widget-reference resources.
     */
    
    XtVaSetValues(instance->cmapscopewindow_mainwin,
        XmNworkWindow, instance->cmapscopewindow_form,
        NULL);
    
    XtVaSetValues(instance->controlpane_frame,
        XmNrightWidget, instance->drawpane,
        NULL);
    
    XtVaSetValues(instance->textfield2_rowcolumn,
        XmNtopWidget, instance->textfield_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->textfield3_rowcolumn,
        XmNtopWidget, instance->textfield2_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->textfield4_rowcolumn,
        XmNtopWidget, instance->textfield3_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->textfield5_rowcolumn,
        XmNleftWidget, instance->textfield_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->textfield6_rowcolumn,
        XmNleftWidget, instance->textfield2_rowcolumn,
        XmNtopWidget, instance->textfield5_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->textfield7_rowcolumn,
        XmNleftWidget, instance->textfield3_rowcolumn,
        XmNtopWidget, instance->textfield6_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->textfield8_rowcolumn,
        XmNleftWidget, instance->textfield4_rowcolumn,
        XmNtopWidget, instance->textfield7_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->separator,
        XmNtopWidget, instance->textfield4_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->radiobox,
        XmNtopWidget, instance->separator,
        NULL);
    
    XtVaSetValues(instance->textfield9_rowcolumn,
        XmNtopWidget, instance->radiobox,
        NULL);

    XtVaSetValues(instance->textfield10_rowcolumn,
        XmNtopWidget, instance->textfield9_rowcolumn,
        NULL);
    
    XtVaSetValues(instance->list2_rowcolumn,
        XmNleftWidget, instance->radiobox,
        XmNtopWidget, instance->separator,
        NULL);
    
    /*
     * Call utility functions to do group layout
     */
    
    
    XtManageChild(instance->textfield_label);
    XtManageChild(instance->textfield);
    XtManageChild(instance->textfield_rowcolumn);
    XtManageChild(instance->textfield2_label);
    XtManageChild(instance->textfield2);
    XtManageChild(instance->textfield2_rowcolumn);
    XtManageChild(instance->textfield3_label);
    XtManageChild(instance->textfield3);
    XtManageChild(instance->textfield3_rowcolumn);
    XtManageChild(instance->textfield4_label);
    XtManageChild(instance->textfield4);
    XtManageChild(instance->textfield4_rowcolumn);
    XtManageChild(instance->textfield5_label);
    XtManageChild(instance->textfield5);
    XtManageChild(instance->textfield5_rowcolumn);
    XtManageChild(instance->textfield6_label);
    XtManageChild(instance->textfield6);
    XtManageChild(instance->textfield6_rowcolumn);
    XtManageChild(instance->textfield7_label);
    XtManageChild(instance->textfield7);
    XtManageChild(instance->textfield7_rowcolumn);
    XtManageChild(instance->textfield8_label);
    XtManageChild(instance->textfield8);
    XtManageChild(instance->textfield8_rowcolumn);
    XtManageChild(instance->separator);
    XtManageChild(instance->radiobox);
    XtManageChild(instance->textfield9_label);
    XtManageChild(instance->textfield9);
    XtManageChild(instance->textfield9_rowcolumn);
    XtManageChild(instance->textfield10_label);
    XtManageChild(instance->textfield10);
    XtManageChild(instance->textfield10_rowcolumn);
    XtManageChild(instance->list2_label);
    XtManageChild(instance->list2);
    XtManageChild(instance->list2_scrolledwin);
    XtManageChild(instance->list2_rowcolumn);
    XtManageChild(instance->button2);
    XtManageChild(instance->controlpane);
    XtManageChild(instance->controlpane_frame);
    XtManageChild(instance->drawpane);
    XtManageChild(instance->cmapscopewindow_form);
    XtManageChild(instance->cmapscopewindow_mainwin);
    
    /*
     * Add User and Connection callbacks
     */
    XtAddCallback(instance->button2,
		  XmNactivateCallback, dtb_quit, 
		  (XtPointer)&(*instance));
    XtAddCallback(instance->drawpane, 
		  XmNinputCallback, dtb_change_map, 
		  (XtPointer)&(*instance));
    XtAddCallback(instance->drawpane,
		  XmNexposeCallback, dtb_draw_expose,
		  (XtPointer)&(*instance));
    XtAddCallback(instance->list2,
		  XmNmultipleSelectionCallback, dtb_list_select,
		  (XtPointer)&(*instance));
    XtAddCallback(instance->radiobox_items.Install_item,
		  XmNvalueChangedCallback, dtb_toggle_change,
		  (XtPointer)&(*instance));
    XtAddCallback(instance->radiobox_items.Uninstall_item,
		  XmNvalueChangedCallback, dtb_toggle_change,
		  (XtPointer)&(*instance));

    sprintf(&buff[0], "%d", MaxCmapsOfScreen(XtScreen(instance->textfield9)));
    XmTextFieldSetString(instance->textfield9, &buff[0]);
    sprintf(&buff[0], "%d", MinCmapsOfScreen(XtScreen(instance->textfield9)));
    XmTextFieldSetString(instance->textfield10, &buff[0]);

    return 0;
}


static int 
dtb_cmapscopeui_cmapscopewindow_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Display	*display= (parent == NULL? NULL:XtDisplay(parent));
    
    if (instance->cmapscopewindow == NULL) {
        instance->cmapscopewindow =
            XtVaAppCreateShell("cmapscope",
                "Cmapscope",
                applicationShellWidgetClass,
                display,
                XmNallowShellResize, FALSE,
                XmNtitle, "Cmapscope Window",
                NULL);
    }
    if (instance->cmapscopewindow == NULL)
        return -1;

    if (instance->cmapscopewindow_mainwin == NULL) {
        instance->cmapscopewindow_mainwin =
            XtVaCreateWidget("dtb_cmapscopeui_cmapscopewindow_mainwin",
                xmMainWindowWidgetClass,
                instance->cmapscopewindow,
		XmNmainWindowMarginWidth, 0,
                NULL);
    }
    if (instance->cmapscopewindow_mainwin == NULL)
        return -1;

    if (instance->cmapscopewindow_form == NULL) {
        instance->cmapscopewindow_form =
            XtVaCreateWidget("dtb_cmapscopeui_cmapscopewindow_form",
                xmFormWidgetClass,
                instance->cmapscopewindow_mainwin,
                XmNmarginHeight, 0,
                XmNmarginWidth, 0,
                XmNresizePolicy, XmRESIZE_NONE,
                NULL);
    }
    if (instance->cmapscopewindow_form == NULL)
        return -1;

    return 0;
}

static int 
dtb_cmapscopeui_controlpane_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    
    if (instance->controlpane_frame == NULL) {
        instance->controlpane_frame =
            XtVaCreateWidget("dtb_cmapscopeui_controlpane",
                xmFrameWidgetClass,
                parent,
                XmNbottomOffset, 0,
                XmNbottomAttachment, XmATTACH_FORM,
                XmNrightOffset, 0,
                XmNrightAttachment, XmATTACH_WIDGET,
                XmNleftOffset, 0,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 0,
                XmNtopAttachment, XmATTACH_FORM,
                XmNshadowType, XmSHADOW_OUT,
                NULL);
    }
    if (instance->controlpane_frame == NULL)
        return -1;

    if (instance->controlpane == NULL) {
        instance->controlpane =
            XtVaCreateWidget("dtb_cmapscopeui_controlpane_obj",
                xmFormWidgetClass,
                instance->controlpane_frame,
                XmNresizePolicy, XmRESIZE_NONE,
                XmNmarginHeight, 0,
                XmNmarginWidth, 0,
                NULL);
    }
    if (instance->controlpane == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_drawpane_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    
    if (instance->drawpane == NULL) {
        drawing = instance->drawpane =
            XtVaCreateWidget("dtb_cmapscopeui_drawpane",
                xmDrawingAreaWidgetClass,
                parent,
                XmNbottomOffset, 0,
                XmNbottomAttachment, XmATTACH_FORM,
                XmNleftOffset, 0,
                XmNleftPosition, 50,
                XmNleftAttachment, XmATTACH_POSITION,
                XmNtopOffset, 0,
                XmNtopAttachment, XmATTACH_FORM,
                XmNheight, 402,
                XmNwidth, 402,
                NULL);
    }
    if (instance->drawpane == NULL)
        return -1;
    return 0;
}



static int 
dtb_cmapscopeui_textfield_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[44];	/* need 39 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield_rowcolumn == NULL) {
        instance->textfield_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 23,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_FORM,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield_rowcolumn == NULL)
        return -1;

    if (instance->textfield_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Number:");
        instance->textfield_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield_label",
                xmLabelWidgetClass,
                instance->textfield_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield_label == NULL)
        return -1;

    if (instance->textfield == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 6);  ++n;
        instance->textfield =
            XmCreateTextField(instance->textfield_rowcolumn,
                "dtb_cmapscopeui_textfield_field", args, n);
    }
    if (instance->textfield == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_textfield2_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[44];	/* need 39 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield2_rowcolumn == NULL) {
        instance->textfield2_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield2",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 37,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 7,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield2_rowcolumn == NULL)
        return -1;

    if (instance->textfield2_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Depth:");
        instance->textfield2_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield2_label",
                xmLabelWidgetClass,
                instance->textfield2_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield2_label == NULL)
        return -1;

    if (instance->textfield2 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 6);  ++n;
        instance->textfield2 =
            XmCreateTextField(instance->textfield2_rowcolumn,
                "dtb_cmapscopeui_textfield2_field", args, n);
    }
    if (instance->textfield2 == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_textfield3_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[44];	/* need 39 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield3_rowcolumn == NULL) {
        instance->textfield3_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield3",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 20,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 7,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield3_rowcolumn == NULL)
        return -1;

    if (instance->textfield3_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Ref. Cnt:");
        instance->textfield3_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield3_label",
                xmLabelWidgetClass,
                instance->textfield3_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield3_label == NULL)
        return -1;

    if (instance->textfield3 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 6);  ++n;
        instance->textfield3 =
            XmCreateTextField(instance->textfield3_rowcolumn,
                "dtb_cmapscopeui_textfield3_field", args, n);
    }
    if (instance->textfield3 == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_textfield4_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[44];	/* need 39 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield4_rowcolumn == NULL) {
        instance->textfield4_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield4",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 6,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield4_rowcolumn == NULL)
        return -1;

    if (instance->textfield4_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Install Req:");
        instance->textfield4_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield4_label",
                xmLabelWidgetClass,
                instance->textfield4_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield4_label == NULL)
        return -1;

    if (instance->textfield4 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 6);  ++n;
        instance->textfield4 =
            XmCreateTextField(instance->textfield4_rowcolumn,
                "dtb_cmapscopeui_textfield4_field", args, n);
    }
    if (instance->textfield4 == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_textfield5_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[38];	/* need 33 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield5_rowcolumn == NULL) {
        instance->textfield5_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield5",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 6,
                XmNleftAttachment, XmATTACH_WIDGET,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_FORM,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield5_rowcolumn == NULL)
        return -1;

    if (instance->textfield5_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Colormap ID:");
        instance->textfield5_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield5_label",
                xmLabelWidgetClass,
                instance->textfield5_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield5_label == NULL)
        return -1;

    if (instance->textfield5 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 12);  ++n;
        instance->textfield5 =
            XmCreateTextField(instance->textfield5_rowcolumn,
                "dtb_cmapscopeui_textfield5_field", args, n);
    }
    if (instance->textfield5 == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_textfield6_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[38];	/* need 33 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield6_rowcolumn == NULL) {
        instance->textfield6_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield6",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 8,
                XmNleftAttachment, XmATTACH_WIDGET,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield6_rowcolumn == NULL)
        return -1;

    if (instance->textfield6_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Visual Class:");
        instance->textfield6_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield6_label",
                xmLabelWidgetClass,
                instance->textfield6_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield6_label == NULL)
        return -1;

    if (instance->textfield6 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 12);  ++n;
        instance->textfield6 =
            XmCreateTextField(instance->textfield6_rowcolumn,
                "dtb_cmapscopeui_textfield6_field", args, n);
    }
    if (instance->textfield6 == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_textfield7_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[38];	/* need 33 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield7_rowcolumn == NULL) {
        instance->textfield7_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield7",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 12,
                XmNleftAttachment, XmATTACH_WIDGET,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield7_rowcolumn == NULL)
        return -1;

    if (instance->textfield7_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Visual Type:");
        instance->textfield7_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield7_label",
                xmLabelWidgetClass,
                instance->textfield7_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield7_label == NULL)
        return -1;

    if (instance->textfield7 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 12);  ++n;
        instance->textfield7 =
            XmCreateTextField(instance->textfield7_rowcolumn,
                "dtb_cmapscopeui_textfield7_field", args, n);
    }
    if (instance->textfield7 == NULL)
        return -1;

    return 0;
}

static int 
dtb_cmapscopeui_textfield8_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[38];	/* need 33 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield8_rowcolumn == NULL) {
        instance->textfield8_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield8",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 55,
                XmNleftAttachment, XmATTACH_WIDGET,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield8_rowcolumn == NULL)
        return -1;

    if (instance->textfield8_label == NULL) {
        label_xmstring = XmStringCreateLocalized("State:");
        instance->textfield8_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield8_label",
                xmLabelWidgetClass,
                instance->textfield8_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield8_label == NULL)
        return -1;

    if (instance->textfield8 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 12);  ++n;
        instance->textfield8 =
            XmCreateTextField(instance->textfield8_rowcolumn,
                "dtb_cmapscopeui_textfield8_field", args, n);
    }
    if (instance->textfield8 == NULL)
        return -1;

    return 0;
}

static int 
dtb_cmapscopeui_separator_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    
    if (instance->separator == NULL) {
        instance->separator =
            XtVaCreateWidget("dtb_cmapscopeui_separator",
                xmSeparatorWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightOffset, 6,
                XmNrightAttachment, XmATTACH_FORM,
                XmNleftOffset, 6,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNseparatorType, XmSHADOW_ETCHED_IN,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->separator == NULL)
        return -1;

    return 0;
}



static int 
dtb_cmapscopeui_radiobox_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[20];	/* need 15 args (add 5 to be safe) */
    int	n = 0;
    Widget	radiobox_items[2];
    static String	radiobox_strings[] =
    {
        "Install", "Uninstall"
    };
    int	i = 0;
    Boolean	radiobox_selected[] =
    {
        False, False
    };
    
    if (instance->radiobox == NULL) {
        n = 0;
        XtSetArg(args[n], XmNbottomAttachment, XmATTACH_NONE);  ++n;
        XtSetArg(args[n], XmNrightAttachment, XmATTACH_NONE);  ++n;
        XtSetArg(args[n], XmNleftOffset, 6);  ++n;
        XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  ++n;
        XtSetArg(args[n], XmNtopOffset, 6);  ++n;
        XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);  ++n;
        XtSetArg(args[n], XmNradioBehavior, False);  ++n;
        XtSetArg(args[n], XmNentryClass, xmToggleButtonWidgetClass);  ++n;
        XtSetArg(args[n], XmNnumColumns, 1);  ++n;
        XtSetArg(args[n], XmNrowColumnType, XmWORK_AREA);  ++n;
        XtSetArg(args[n], XmNorientation, XmHORIZONTAL);  ++n;
        XtSetArg(args[n], XmNspacing, 0);  ++n;
        XtSetArg(args[n], XmNpacking, XmPACK_TIGHT);  ++n;
        XtSetArg(args[n], XmNisHomogeneous, True);  ++n;
        instance->radiobox =
            XmCreateRadioBox(parent,
                "dtb_cmapscopeui_radiobox", args, n);
    }
    if (instance->radiobox == NULL)
        return -1;

    for (i = 0; i < XtNumber(radiobox_strings); i++)
    {
        label_xmstring = XmStringCreateLocalized(radiobox_strings[i]);
        radiobox_items[i] = XtVaCreateManagedWidget("dtb_cmapscopeui_radiobox_install_item",
            xmToggleButtonWidgetClass,
            instance->radiobox,
            XmNset, radiobox_selected[i],
            XmNlabelString, label_xmstring,
            NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    instance->radiobox_items.Install_item = radiobox_items[0];
    instance->radiobox_items.Uninstall_item = radiobox_items[1];
    return 0;
}


static int 
dtb_cmapscopeui_textfield9_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[38];	/* need 33 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield9_rowcolumn == NULL) {
        instance->textfield9_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield9",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 12,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 12,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield9_rowcolumn == NULL)
        return -1;

    if (instance->textfield9_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Max Colormaps:");
        instance->textfield9_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield9_label",
                xmLabelWidgetClass,
                instance->textfield9_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield9_label == NULL)
        return -1;

    if (instance->textfield9 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 3);  ++n;
        instance->textfield9 =
            XmCreateTextField(instance->textfield9_rowcolumn,
                "dtb_cmapscopeui_textfield9_field", args, n);
    }
    if (instance->textfield9 == NULL)
        return -1;

    return 0;
}

static int 
dtb_cmapscopeui_textfield10_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[38];	/* need 33 args (add 5 to be safe) */
    int	n = 0;
    
    if (instance->textfield10_rowcolumn == NULL) {
        instance->textfield10_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_textfield10",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomAttachment, XmATTACH_NONE,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 17,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_END,
                XmNorientation, XmHORIZONTAL,
                NULL);
    }
    if (instance->textfield10_rowcolumn == NULL)
        return -1;

    if (instance->textfield10_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Min Colormaps:");
        instance->textfield10_label =
            XtVaCreateWidget("dtb_cmapscopeui_textfield10_label",
                xmLabelWidgetClass,
                instance->textfield10_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->textfield10_label == NULL)
        return -1;

    if (instance->textfield10 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNmaxLength, 80);  ++n;
        XtSetArg(args[n], XmNeditable, False);  ++n;
        XtSetArg(args[n], XmNcursorPositionVisible, False);  ++n;
        XtSetArg(args[n], XmNcolumns, 3);  ++n;
        instance->textfield10 =
            XmCreateTextField(instance->textfield10_rowcolumn,
                "dtb_cmapscopeui_textfield10_field", args, n);
    }
    if (instance->textfield10 == NULL)
        return -1;

    return 0;
}

static int 
dtb_cmapscopeui_list2_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    Arg	args[19];	/* need 14 args (add 5 to be safe) */
    int	n = 0;
    
    
    if (instance->list2_rowcolumn == NULL) {
        instance->list2_rowcolumn =
            XtVaCreateWidget("dtb_cmapscopeui_list2",
                xmRowColumnWidgetClass,
                parent,
                XmNbottomOffset, 6,
                XmNbottomAttachment, XmATTACH_FORM,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 18,
                XmNleftAttachment, XmATTACH_WIDGET,
                XmNtopOffset, 6,
                XmNtopAttachment, XmATTACH_WIDGET,
                XmNadjustLast, True,
                XmNmarginWidth, 0,
                XmNmarginHeight, 0,
                XmNentryAlignment, XmALIGNMENT_BEGINNING,
                XmNorientation, XmVERTICAL,
                NULL);
    }
    if (instance->list2_rowcolumn == NULL)
        return -1;

    if (instance->list2_label == NULL) {
        label_xmstring = XmStringCreateLocalized("Colormap IDs:");
        instance->list2_label =
            XtVaCreateWidget("dtb_cmapscopeui_list2_label",
                xmLabelWidgetClass,
                instance->list2_rowcolumn,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->list2_label == NULL)
        return -1;

    if (instance->list2 == NULL) {
        n = 0;
        XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmAUTOMATIC);  ++n;
        XtSetArg(args[n], XmNlistSizePolicy, XmVARIABLE);  ++n;
        XtSetArg(args[n], XmNselectionPolicy, XmMULTIPLE_SELECT);  ++n;
        XtSetArg(args[n], XmNvisibleItemCount, 10);  ++n;
        instance->list2 =
            XmCreateScrolledList(instance->list2_rowcolumn,
                "dtb_cmapscopeui_list2_list", args, n);
    }
    instance->list2_scrolledwin = XtParent(instance->list2);
    if (instance->list2 == NULL)
        return -1;

    return 0;
}

static int 
dtb_cmapscopeui_button2_create(
    DtbCmapscopeuiCmapscopewindowInfo instance,
    Widget parent
)
{
    XmString	label_xmstring = NULL;
    
    if (instance->button2 == NULL) {
        label_xmstring = XmStringCreateLocalized("Quit");
        instance->button2 =
            XtVaCreateWidget("dtb_cmapscopeui_button2",
                xmPushButtonWidgetClass,
                parent,
                XmNbottomOffset, 12,
                XmNbottomAttachment, XmATTACH_FORM,
                XmNrightAttachment, XmATTACH_NONE,
                XmNleftOffset, 12,
                XmNleftAttachment, XmATTACH_FORM,
                XmNtopAttachment, XmATTACH_NONE,
                XmNrecomputeSize, True,
                XmNalignment, XmALIGNMENT_CENTER,
                XmNlabelType, XmSTRING,
                XmNlabelString, label_xmstring,
		XmNmarginWidth, 6,
                NULL);
        XmStringFree(label_xmstring);
        label_xmstring = NULL;
    }
    if (instance->button2 == NULL)
        return -1;

    return 0;
}

Bool dtb_install_toggle()
{
  Widget install = 
    dtb_cmapscopeui_cmapscopewindow.radiobox_items.Install_item;

  return (Bool) XmToggleButtonGetState(install);
}

Bool dtb_uninstall_toggle()
{
  Widget uninstall = 
    dtb_cmapscopeui_cmapscopewindow.radiobox_items.Uninstall_item;

  return (Bool) XmToggleButtonGetState(uninstall);
}
