/******************************************************************************
 * $Id$
 * 
 * Source File Name: cmapscope_ui.h
 * 
 *   	 Copyright (c) 1991-96 International Business Machines Corp.
 *                     11400 Burnet Rd. Austin, TX. 78758
 *  
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of International Business Machines Corp. may not be used in 
 * any advertising or publicity relating to the software without the specific, 
 * prior written permission of International Business Machines Corp.
 * 
 * The software is provided AS-IS and without WARRANTY of any kind,
 * express, implied or otherwise, including without limitation, any
 * warranty of merchantabilityl or fitness for a particular purpose.
 * 
 * In no event shall International Business Machines Corp. be liable for any 
 * special, incidental, indirect or consequential damages of any kind, or any 
 * damages whatsoever resulting from loss of use, data or profits, whether or 
 * not advised of the possibility of damage, and on any theory of liability, 
 * arising out of or in connection with the use or performance of this 
 * software. Contractor is International Business Machines Corp.
 * 
 * Language: C
 * 
 * Description: 
 * 
 * Revision History: 
 *  01/07/97  Ronald O. Edmark Initial Coding.
 *     
 *****************************************************************************/
#ifndef _CMAPSCOPEUI_UI_H_
#define _CMAPSCOPEUI_UI_H_

#include <stdlib.h>
#include <X11/Intrinsic.h>

/*
 * User Interface Objects
 */
/*
 * Shared data structures
 */

typedef struct {
    Widget	Install_item;
    Widget	Uninstall_item;
} CmapscopeuiRadioboxItemsRec, *CmapscopeuiRadioboxItems;

typedef struct
{
    Boolean	initialized;
    
    Widget	cmapscopewindow;	/* object "cmapscopewindow" */
    Widget	cmapscopewindow_mainwin;
    Widget	cmapscopewindow_form;
    
    Widget	controlpane_frame;	/* object "controlpane" */
    Widget	controlpane;
    
    Widget	drawpane;
    
    Widget	textfield_rowcolumn;	/* object "textfield" */
    Widget	textfield_label;
    Widget	textfield;
    
    Widget	textfield2_rowcolumn;	/* object "textfield2" */
    Widget	textfield2_label;
    Widget	textfield2;
    
    Widget	textfield3_rowcolumn;	/* object "textfield3" */
    Widget	textfield3_label;
    Widget	textfield3;
    
    Widget	textfield4_rowcolumn;	/* object "textfield4" */
    Widget	textfield4_label;
    Widget	textfield4;
    
    Widget	textfield5_rowcolumn;	/* object "textfield5" */
    Widget	textfield5_label;
    Widget	textfield5;
    
    Widget	textfield6_rowcolumn;	/* object "textfield6" */
    Widget	textfield6_label;
    Widget	textfield6;
    
    Widget	textfield7_rowcolumn;	/* object "textfield7" */
    Widget	textfield7_label;
    Widget	textfield7;
    
    Widget	textfield8_rowcolumn;	/* object "textfield8" */
    Widget	textfield8_label;
    Widget	textfield8;
    
    Widget	separator;
    
    Widget	radiobox;	/* object "radiobox" */
    CmapscopeuiRadioboxItemsRec	radiobox_items;
    
    Widget	textfield9_rowcolumn;	/* object "textfield8" */
    Widget	textfield9_label;
    Widget	textfield9;

    Widget	textfield10_rowcolumn;	/* object "textfield8" */
    Widget	textfield10_label;
    Widget	textfield10;

    Widget	list2_rowcolumn;	/* object "list2" */
    Widget	list2_label;
    Widget	list2_scrolledwin;
    Widget	list2;
    
    Widget	button2;
} DtbCmapscopeuiCmapscopewindowInfoRec, *DtbCmapscopeuiCmapscopewindowInfo;

extern DtbCmapscopeuiCmapscopewindowInfoRec dtb_cmapscopeui_cmapscopewindow;

/*
 * Structure Clear Procedures: These set the fields to NULL
 */
int dtbCmapscopeuiCmapscopewindowInfo_clear(DtbCmapscopeuiCmapscopewindowInfo instance);

/*
 * Structure Initialization Procedures: These create the widgets
 */
int dtb_cmapscopeui_cmapscopewindow_initialize(
    DtbCmapscopeuiCmapscopewindowInfo	instance,
    Widget	parent
);

/*
 * User Callbacks
 */
void map_output_text_dlg(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_draw_expose(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_draw_create(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_draw_resize(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_toggle_change(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_dialog_show(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_dialog_hide(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_window_created(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);
void dtb_list_select(
    Widget	widget,
    XtPointer	clientData,
    XtPointer	callData
);

#endif /* _CMAPSCOPEUI_UI_H_ */
