/******************************************************************************
 * $Id$
 * 
 * Source File Name: cmapscopeui_stubs.c
 * 
 *   	 Copyright (c) 1991-96 International Business Machines Corp.
 *                     11400 Burnet Rd. Austin, TX. 78758
 *  
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee, provided
 * that the name of International Business Machines Corp. may not be used in 
 * any advertising or publicity relating to the software without the specific, 
 * prior written permission of International Business Machines Corp.
 * 
 * The software is provided AS-IS and without WARRANTY of any kind,
 * express, implied or otherwise, including without limitation, any
 * warranty of merchantabilityl or fitness for a particular purpose.
 * 
 * In no event shall International Business Machines Corp. be liable for any 
 * special, incidental, indirect or consequential damages of any kind, or any 
 * damages whatsoever resulting from loss of use, data or profits, whether or 
 * not advised of the possibility of damage, and on any theory of liability, 
 * arising out of or in connection with the use or performance of this 
 * software. Contractor is International Business Machines Corp.
 * 
 * Language: "C"
 * 
 * Description: 
 * 
 * Revision History: 
 *  01/07/97  Ronald O. Edmark  Initial Coding.
 *     
 *****************************************************************************/
#include <stdio.h>
#include <Xm/Xm.h>
#include "cmapscope_ui.h"

extern void cmsChangeMap(Bool);
extern void cmsSelectColormap(int *, int);

void 
dtb_quit(
    Widget widget,
    XtPointer clientData,
    XtPointer callData
)
{
  XmPushButtonCallbackStruct *pbs = (XmPushButtonCallbackStruct *) callData;
  XEvent *event = pbs->event;

  if (pbs->reason == XmCR_ACTIVATE)
    exit(0);
}

void 
dtb_toggle_change(
    Widget widget,
    XtPointer clientData,
    XtPointer callData
)
{
}

void 
dtb_list_select(
    Widget widget,
    XtPointer clientData,
    XtPointer callData
)
{
  XmListCallbackStruct* cbs = (XmListCallbackStruct*) callData;

  cmsSelectColormap(&cbs->selected_item_positions[0], 
		    cbs->selected_item_count);
}

void dtb_change_map(
    Widget widget,
    XtPointer clientData,
    XtPointer callData
)
{
  XmDrawingAreaCallbackStruct *cbs = (XmDrawingAreaCallbackStruct *)callData;
  XEvent *event = cbs->event;

  if ((cbs->reason == XmCR_INPUT) && (event->xany.type == ButtonRelease)) {
    cmsChangeMap(True);    
  }
}

void dtb_draw_expose(
    Widget widget,
    XtPointer clientData,
    XtPointer callData
)
{
  XmDrawingAreaCallbackStruct *cbs = (XmDrawingAreaCallbackStruct *)callData;
  XEvent *event = cbs->event;
  XExposeEvent* expose = (XExposeEvent*) event;

  if ((cbs->reason == XmCR_EXPOSE) && (expose->count == 0)) {
    cmsChangeMap(False); 
  }
}
